***   XT analysis3 do file
* using 24aug2010.dta       XTmixed analysis  :: controlling for multiple levels of clustering
* Robert A. Yaffee    file on Toshi1
set memory 2G
log using XTanalysis4, replace
use "C:\Users\ry\stats\stata\data\research\chwk\nsfposter\data\panel\data\ch3w24aug2010.dta", clear
set more off
set linesize 80
poster
dis c(pwd)
dis c(filename)
dis c(memory)

datasignature report




xtset id wave

describe radhlw gender agew agewsq radfmw injselfr hp2inthob airw beerw lcumdosew raind1-raind23 wave
xtdescribe radhlw gender agew agewsq radfmw injselfr hp2inthob airw beerw lcumdosew raind1-raind23 wave
xtsum radhlw gender agew agewsq radfmw injselfr hp2inthob airw beerw lcumdosew raind1-raind23 wave


cap gen period=wave
label var period "wave"
cap gen agewsq = agew*agew
label var agewsq "age of respondent squared"
bs, reps(200) bca: xtmixed radhlw gender  || id:   //  we can bootstrap xtmixed if there is but one level
tab ranow1

* testing for endogeneity with the robust Hausman test  Wooldridge 2002 found in Cameron and Trivedi 
* classical Hausman  test

xtreg radhlw gender agew agewsq radfmw injselfr hp2inthob airw beerw lcumdosew, i(id) fe
est store fixed
xtreg radhlw gender agew agewsq radfmw injselfr hp2inthob airw beerw lcumdosew, i(id) re 
est store random
hausman fixed random, sigmamore





* Robust Hausman test from Wooldrige (2002) found in Cameron and Trivedi on page 262

set more off
global xlist1 radfmw radchw radtlw lcumdosew sex agew beerw hp2inthob CSsocspt injselfr
global xlist2 radfmw radtlw radchw radw 
quietly xtreg radhlw $xlist1, re
scalar theta = e(thta_max)
global yandxforHausman1 radhlw radfmw radchw radtlw lcumdosew sex agew beerw hp2inthob CSsocspt injselfr
sort id
cap drop  meanradhlw- redinjselfr
foreach x of varlist $yandxforHausman1 {
   summarize `x', detail
   gen mean`x'= r(mean)
   gen md`x'=  `x'- r(mean)
   gen red`x' = `x' - theta*mean`x'
  }
quietly regress redradhlw redradfmw redradchw redradtlw redlcumdosew redsex redagew redbeerw redhp2inthob ///
   redCSsocspt redinjselfr mdradhlw mdradfmw mdradchw mdradtlw mdlcumdosew mdsex mdagew mdbeerw ///
     mdhp2inthob mdCSsocspt mdinjselfr
test mdradhlw mdradfmw mdradtlw mdradchw 
quietly regress redradhlw mdradfmw redradchw redradtlw redlcumdosew redsex redagew mdradhlw mdradchw mdradtlw ///
      mdlcumdosew mdsex mdagew 
test  mdradfmw mdradchw mdradtlw 


* table 1   Correlation matrix of residuals with explanatory variables
describe radhlw ivr2 radfmw radchw radtlw lcumdosew sex agew beerw hp2inthob CSsocspt injselfr, sig obs
pwcorr radhlw ivr2 radfmw radchw radtlw lcumdosew sex agew beerw hp2inthob CSsocspt injselfr, sig obs





* table 2   Two-stage least squares instrumental variables test of  model and endogeneity
ssc install ranktest, replace 
set more off
xtset id wave
ivreg2 radhlw sex agew beerw lcumdosew hp2inthob CSsocspt injselfr  /// 
   (radfmw=radtlw airw radchw ),  endog(radfmw ) cluster(id) small plus first
ivhettest, fitsq 


* Retest of endogeniety of explanatory variables   Table 3
reg3 (radhlw=sex agew injselfr lcumdosew radfmw) (radfmw=sex agew lcumdosew radhlw radchw medw) ///
  (radchw=sex agew radhlw radw)(radtlw= sex agew radhlw radchw inselfr lcumdosew)
  


* Population average model  Table 4
xtset id wave
xtgee radhlw sex agew CSsocspt beerw injselfr hp2inthob lcumdosew ranow1, i(id) corr(ar 2) robust


cap gen ldoseXwave=wave*lcumdosew
label var ldoseXwave "First-order interaction between wave and lcumdosew"
*    Three level random intercepts mixed model 
***  xtmixed analysis with three levels with random intercepts 

cumdose_ygy
lowess cumdoseugy wave, title( Cumulative external 137 CS in uGy by wave )  ///
    ytitle("cumulative external dose 137CS" "in micro_Gy")  legend(rows(4))

set more off
capture drop mixres1
capture drop rstd1
capture drop mixedfit
describe radhlw sex agew CSsocspt injselfr hp2inthob lcumdosew ranow1 
xtmixed radhlw sex agew wave CSsocspt liqw injselfr hp2inthob lcumdosew  || ranow1: ///
      || id:  || wave:, ml nolog technique(nr bfgs) variance
	  // * testing the model
predict mixres1, residual
predict rstd1, rstandard
predict mixedfit, fitted


estat group
estat recov
estat recov, level(id)
estat recov, level(wave)
estat recov, level(ranow1)


capture drop u10
capture drop u20
capture drop u30
predict u10 u20 u30, reffects


estat ic 
estat summarize, labels equation
estat group 
estat recov

extremes rstd1    // no evidence of outliers
// test for normality of residuals
sktest mixres1    // global residuals are nonnormal
swilk mixres1
hist mixres1, normal  title(Mixed model residuals)  subtitle(symmetric but leptokurtotic)
// leptokurtotic residuals  but distribution appears symmetrical
summarize mixres1, detail
***************************************************
* model 2 without the spatial layer
xtmixed radhlw sex agew wave CSsocspt liqw injselfr hp2inthob lcumdosew  ///
      || id:  || wave:, ml nolog technique(nr bfgs) variance
	  // * testing the model
predict mixres2, residual
predict rstd2, rstandard
predict mixedfit2, fitted
. est stats _all

-----------------------------------------------------------------------------
       Model |    Obs    ll(null)   ll(model)     df          AIC         BIC
-------------+---------------------------------------------------------------
        mod2 |    797           .   -3698.794     12     7421.588    7477.758
        mod1 |    797           .   -3696.414     13     7418.828    7479.679
-----------------------------------------------------------------------------
               Note:  N=Obs used in calculating BIC; see [R] BIC note

. dis -2 *( - 3698.794 + 3696.414)
4.76

. dis "p_ch2 = ",chi2tail(1,4.76)
p_ch2 =  .02912855

